<?php

namespace SM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\ApropriacaoRecursosService;
use SM\Traits\TResponse;

class ApropriacaoRecursosController
{
    use TResponse;
    
    protected $apropriacaoRecursosService;
    
    public function __construct(ApropriacaoRecursosService $apropriacaoRecursosService)
    {
        $this->apropriacaoRecursosService = $apropriacaoRecursosService;
    }
    
    public function getApropAgendamento()
    {
        try {
            $data = $this->apropriacaoRecursosService->getApropAgendamento();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getRecursosApropAgendamento()
    {
        try {
            $data = $this->apropriacaoRecursosService->getRecursosApropAgendamento();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}