<?php

namespace SM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\DesalocarRecursosService;
use SM\Traits\TResponse;

class DesalocarRecursosController
{
    use TResponse;
    
    protected $desalocarRecursosService;
    
    public function __construct(DesalocarRecursosService $desalocarRecursosService)
    {
        $this->desalocarRecursosService = $desalocarRecursosService;
    }

    public function saveDesalocarRecursos(Request $request) {
        try {
            $data = $this->desalocarRecursosService->saveDesalocarRecursos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        } 
    }
}