<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class DesalocarRecursosFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function saveDesalocarRecursos(array $params){
        
        $sql = "INSERT INTO FCT_DEVAGENDRECURCON (
                    NRDEVAGENDRECURCON,
                    NRRECURSOSAGENDCONT,
                    DTDEVAGENDRECURCON,
                    NRORG,
                    IDATIVO,
                    DTINCLUSAO,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    DTULTATU,
                    NRORGULTATU,
                    CDOPERULTATU
                    )
                VALUES (
                    :NRDEVAGENDRECURCON,
                    :NRRECURSOSAGENDCONT,
                    :DTDEVAGENDRECURCON,
                    :NRORG,
                    :IDATIVO,
                    SYSDATE,
                    :NRORGINCLUSAO,
                    :CDOPERINCLUSAO,
                    :DTULTATU,
                    :NRORGULTATU,
                    :CDOPERULTATU
                	 )";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }

    public function atualizarSituacaoDoAgendamneto($parametros) {

        $sql = "UPDATE FCT_RECURSOSAGENDCONT
                SET IDSITUARECGEND = :IDSITUARECGEND
                WHERE NRRECURSOSAGENDCONT = :NRRECURSOSAGENDCONT
                AND NRORG = :NRORG";
        
        $this->connection->executeStatement($sql, $parametros);
    }
}