<?php

namespace SM\Service;

use SM\Factory\ApropriacaoRecursosFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class ApropriacaoRecursosService
{
    protected $entityManager;
    protected $apropriacaoRecursosFactory;
    protected $environment;
    protected $newCode;
    protected $connection;

    public function __construct(EntityManager $entityManager, ApropriacaoRecursosFactory $apropriacaoRecursosFactory, Environment $environment, NewCode $newCode)
    {
        $this->apropriacaoRecursosFactory   = $apropriacaoRecursosFactory;
        $this->connection                   = $entityManager->getConnection();
        $this->environment                  = $environment;
        $this->newCode                      = $newCode;
    }

    public function getApropAgendamento()
    {
        return $this->apropriacaoRecursosFactory->getApropAgendamento();
    } 

    public function getRecursosApropAgendamento()
    {
        $nrorg = $this->environment->getNrorg();
        $cdtipo = '1'; // Apenas Recursos do tipo 'Pessoa'

        $parametros = array(
            "NRORG"     => $nrorg,
            "CDTIPO"    => $cdtipo
        );

        return $this->apropriacaoRecursosFactory->getRecursosApropAgendamento($parametros);
    }
}