/* Tabela ESTADO: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela ESTADO */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Item do ESTADO, utilizando a tabela Geral de Logs de Operaes */
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_ESTADO' AND
                 TYPE   = 'TR' 	            AND
	              U.UID  = O.UID        AND
	              U.NAME = USER)
DROP TRIGGER LOG_GER_ESTADO
GO

CREATE TRIGGER LOG_GER_ESTADO
ON ESTADO
FOR INSERT, UPDATE, DELETE
AS
   DECLARE  @V_USUARIO             VARCHAR(40);
   DECLARE  @V_TIPO                VARCHAR(1);
   DECLARE  @V_ITPESQ              VARCHAR(40);
   DECLARE  @V_DESC                VARCHAR(1000);
   DECLARE  @V_DTOPER              DATETIME;
   DECLARE  @V_DSREMOTEADDR        VARCHAR(15);
   DECLARE  @V_DSREMOTEHOST        VARCHAR(15);
   DECLARE  @V_DSSERVERRDM         VARCHAR(20);
   DECLARE  @V_DSSERVMETHOD        VARCHAR(30);
   DECLARE  @V_DSREMOTEOPER        VARCHAR(12);

   /*VARIVEIS DO CURSOR C_CURSORi*/
   DECLARE  @V_ID_COMANDO          VARCHAR(1);
   DECLARE  @V_CDPAIS_OLD  VARCHAR(4);
   DECLARE  @V_SGESTADO_OLD  VARCHAR(2);
   DECLARE  @V_NMESTADO_OLD  VARCHAR(30);
   DECLARE  @V_CDESTAEXPO_OLD  VARCHAR(2);
   DECLARE  @V_CDESTADOIBGE_OLD  VARCHAR(2);
   DECLARE  @V_IDUTHORVER_OLD  VARCHAR(1);
   DECLARE  @V_HRDIFUTCFUSO_OLD  VARCHAR(6);
   DECLARE  @V_CDPAIS_NEW  VARCHAR(4);
   DECLARE  @V_SGESTADO_NEW  VARCHAR(2);
   DECLARE  @V_NMESTADO_NEW  VARCHAR(30);
   DECLARE  @V_CDESTAEXPO_NEW  VARCHAR(2);
   DECLARE  @V_CDESTADOIBGE_NEW  VARCHAR(2);
   DECLARE  @V_IDUTHORVER_NEW  VARCHAR(1);
   DECLARE  @V_HRDIFUTCFUSO_NEW  VARCHAR(6);
BEGIN

   SET @V_TIPO = '0';

   SET @V_DESC = '';

   DECLARE C_CURSORi CURSOR FOR

   SELECT
     'D' AS IDCOMANDO,
     CDPAIS,
     SGESTADO,
     NMESTADO,
     CDESTAEXPO,
     CDESTADOIBGE,
     IDUTHORVER,
     HRDIFUTCFUSO,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL
   FROM
     DELETED
   WHERE
     CDPAIS NOT IN (SELECT CDPAIS FROM INSERTED)

   UNION ALL

   SELECT 
     'U' AS IDCOMANDO,
     DELETED.CDPAIS,
     DELETED.SGESTADO,
     DELETED.NMESTADO,
     DELETED.CDESTAEXPO,
     DELETED.CDESTADOIBGE,
     DELETED.IDUTHORVER,
     DELETED.HRDIFUTCFUSO,
     INSERTED.CDPAIS,
     INSERTED.SGESTADO,
     INSERTED.NMESTADO,
     INSERTED.CDESTAEXPO,
     INSERTED.CDESTADOIBGE,
     INSERTED.IDUTHORVER,
     INSERTED.HRDIFUTCFUSo
   FROM
     INSERTED,
     DELETED
   WHERE
     INSERTED.CDPAIS = DELETED.CDPAIS

   UNION ALL

   SELECT 
     'I' AS IDCOMANDO,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     CDPAIS,
     SGESTADO,
     NMESTADO,
     CDESTAEXPO,
     CDESTADOIBGE,
     IDUTHORVER,
     HRDIFUTCFUSO
   FROM
     INSERTED
   WHERE
     CDPAIS NOT IN (SELECT CDPAIS FROM DELETED);

   OPEN C_CURSORi;

   FETCH NEXT FROM C_CURSORi INTO @V_ID_COMANDO,
                                  @V_CDPAIS_OLD,
                                  @V_SGESTADO_OLD,
                                  @V_NMESTADO_OLD,
                                  @V_CDESTAEXPO_OLD,
                                  @V_CDESTADOIBGE_OLD,
                                  @V_IDUTHORVER_OLD,
                                  @V_HRDIFUTCFUSO_OLD,
                                  @V_CDPAIS_NEW,
                                  @V_SGESTADO_NEW,
                                  @V_NMESTADO_NEW,
                                  @V_CDESTAEXPO_NEW,
                                  @V_CDESTADOIBGE_NEW,
                                  @V_IDUTHORVER_NEW,
                                  @V_HRDIFUTCFUSO_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_ID_COMANDO = 'D' BEGIN

         SET @V_TIPO ='3';

         SET @V_ITPESQ = @V_CDPAIS_OLD + @V_SGESTADO_OLD;

         IF @V_CDPAIS_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Pais=' + @V_CDPAIS_OLD;
         END;

         IF @V_SGESTADO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SiglaEst=' + @V_SGESTADO_OLD;
         END;

         IF @V_NMESTADO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NomeEstado=' + @V_NMESTADO_OLD;
         END;

         IF @V_CDESTAEXPO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CodExport=' + @V_CDESTAEXPO_OLD;
         END;

         IF @V_CDESTADOIBGE_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CodIBGE=' + @V_CDESTADOIBGE_OLD;
         END;

         IF @V_IDUTHORVER_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' HorVerao=' + @V_IDUTHORVER_OLD;
         END;

         IF @V_HRDIFUTCFUSO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' FusoHor=' + @V_HRDIFUTCFUSO_OLD;
         END;

      END ELSE BEGIN

         IF @V_ID_COMANDO = 'U' BEGIN

            IF (ISNULL(@V_CDPAIS_OLD,'!')       <> ISNULL(@V_CDPAIS_NEW,'!'))       OR
               (ISNULL(@V_SGESTADO_OLD,'!')     <> ISNULL(@V_SGESTADO_NEW,'!'))     OR
               (ISNULL(@V_NMESTADO_OLD,'!')     <> ISNULL(@V_NMESTADO_NEW,'!'))     OR
               (ISNULL(@V_CDESTAEXPO_OLD,'!')   <> ISNULL(@V_CDESTAEXPO_NEW,'!'))   OR
               (ISNULL(@V_CDESTADOIBGE_OLD,'!') <> ISNULL(@V_CDESTADOIBGE_NEW,'!')) OR
               (ISNULL(@V_IDUTHORVER_OLD,'!')   <> ISNULL(@V_IDUTHORVER_NEW,'!'))   OR
               (ISNULL(@V_HRDIFUTCFUSO_OLD,'!') <> ISNULL(@V_HRDIFUTCFUSO_NEW,'!')) BEGIN

            SET @V_ITPESQ = @V_CDPAIS_OLD + @V_SGESTADO_OLD;
               SET @V_TIPO = '2';
            END;

         END ELSE BEGIN

            SET @V_TIPO   = '1';

            SET @V_ITPESQ = @V_CDPAIS_NEW + @V_SGESTADO_NEW;

         END;

         IF ISNULL(@V_CDPAIS_NEW, '!') <> ISNULL(@V_CDPAIS_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + ' Pais=' + ISNULL(@V_CDPAIS_NEW, '');
         END;

         IF ISNULL(@V_SGESTADO_NEW, '!') <> ISNULL(@V_SGESTADO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + ' SiglaEst=' + ISNULL(@V_SGESTADO_NEW, '');
         END;

         IF ISNULL(@V_NMESTADO_NEW, '!') <> ISNULL(@V_NMESTADO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + ' NomeEstado=' + ISNULL(@V_NMESTADO_NEW, '');
         END;

         IF ISNULL(@V_CDESTAEXPO_NEW, '!') <> ISNULL(@V_CDESTAEXPO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + ' CodExport=' + ISNULL(@V_CDESTAEXPO_NEW, '');
         END;

         IF ISNULL(@V_CDESTADOIBGE_NEW, '!') <> ISNULL(@V_CDESTADOIBGE_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + ' CodIBGE=' + ISNULL(@V_CDESTADOIBGE_NEW, '');
         END;

         IF ISNULL(@V_IDUTHORVER_NEW, '!') <> ISNULL(@V_IDUTHORVER_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + ' HorVerao=' + ISNULL(@V_IDUTHORVER_NEW, '');
         END;

         IF ISNULL(@V_HRDIFUTCFUSO_NEW, '!') <> ISNULL(@V_HRDIFUTCFUSO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + ' FusoHor=' + ISNULL(@V_HRDIFUTCFUSO_NEW, '');
         END;

      END;

      IF @V_TIPO <> '0' BEGIN

         EXEC NMUSUARIO  @V_USUARIO OUTPUT;

         EXEC WEBTUNNING @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                         @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                         @P_DSSERVERRDM  = @V_DSSERVERRDM  OUTPUT,
                         @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                         @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;

         SET @V_USUARIO = ISNULL(@V_USUARIO, '');

         IF @V_DESC IS NOT NULL BEGIN

            IF NOT @V_USUARIO IS NULL BEGIN

               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA, DTOPERACAO, NMRESPOPER, IDTIPOOPER, 
                   CDPESQITEM, DSOPERACAO, DSRDMUSUOPER, DSENDUSUOPER, 
                   DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
               VALUES
                  ('ESTADO', @V_DTOPER, @V_USUARIO, @V_TIPO,
                   @V_ITPESQ, SUBSTRING(@V_DESC,1,300), @V_DSREMOTEADDR, @V_DSREMOTEHOST, 
                   @V_DSSERVERRDM, @V_DSSERVMETHOD, @V_DSREMOTEOPER);

            END;

         END;

      END;

      FETCH NEXT FROM C_CURSORi INTO @V_ID_COMANDO,
                                     @V_CDPAIS_OLD,
                                     @V_SGESTADO_OLD,
                                     @V_NMESTADO_OLD,
                                     @V_CDESTAEXPO_OLD,
                                     @V_CDESTADOIBGE_OLD,
                                     @V_IDUTHORVER_OLD,
                                     @V_HRDIFUTCFUSO_OLD,
                                     @V_CDPAIS_NEW,
                                     @V_SGESTADO_NEW,
                                     @V_NMESTADO_NEW,
                                     @V_CDESTAEXPO_NEW,
                                     @V_CDESTADOIBGE_NEW,
                                     @V_IDUTHORVER_NEW,
                                     @V_HRDIFUTCFUSO_NEW;

   END;

   CLOSE C_CURSORi;

   DEALLOCATE C_CURSORi;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_ESTADO','5.50.000';
